<?php
// (c) Juergen Galupki  http://galupki.de

require_once("lib/kalender.class.php");
require_once("lib/feiertage.class.php");
require_once("lib/sonnemond.class.php");

$kal   = new kalender;
$fd    = new feiertage;
$astro = new sonnemond;

$fd->liesFeiertage("data/feiertage.csv");

# Uebergabeparameter: **************************************************************************

# default: aktuelles Jahr/ 1.1.
if ($jahr=="") {
   $jahr = date("Y");
}
if ($monat=="") {
   $monat = 1;
}
if ($tag=="") {
   $tag = 1;
}

# rechnen
if ($was=="") {
   $was = "d";
}
if ($tage=="") {
   $tage = 0;
}
if ($bjahr=="") {
   $bjahr = date("Y");
}
if ($bmonat=="") {
   $bmonat = 12;
}
if ($btag=="") {
   $btag = 31;
}



# fuer Berechnungen Tabellenfelder - groessen
if ($pxbreite=="") {
   $pxbreite = 800;
}
if ($pxhoehe=="") {
   $pxhoehe  = 600;
}


if ($zenith=="") {
   $zenith = 90.8333; // sonne geht/kommt hinter horizont
}
# default: Niederpleis :-)
if ($lon=="") {
   $lon    = 7.2122;
}
if ($lat=="") {
   $lat    = 50.775;
}
# Abweichung zur UTC-Zeit: anzugeben sind Grunddifferenz zur Location. Sommerzeit!
if ($diff=="") {
   $diff   = 1;
}


# Definition Arbeitstage
if ($at1=="") {
   $at1 = $fd->at[1];
}
if ($at2=="") {
   $at2 = $fd->at[2];
}
if ($at3=="") {
   $at3 = $fd->at[3];
}
if ($at4=="") {
   $at4 = $fd->at[4];
}
if ($at5=="") {
   $at5 = $fd->at[5];
}
if ($at6=="") {
   $at6 = $fd->at[6];
}
if ($at7=="") {
   $at7 = $fd->at[7];
}


# Arbeitstage und regionale Feiertage ggfs. ueberschreiben
if ($submit=="neu berechnen") {
   $fd->setzeArbeitstage( $at1, $at2, $at3, $at4, $at5, $at6, $at7 );
   foreach ($fd->ft as $k => $f) {
      if ( $f["reg"]=="x" OR $f["reg"]=="X" ) {
         $assign = "ft" . $k;
         $fd->ft[$k]["fak"] = $$assign;
      } // endif regional
   } // end foreach Feiertag
}

$heute = $kal->heute();               // fuer Markierung akt. Tag



   $css = htmlspecialchars($css, ENT_QUOTES);
   $jahr = htmlspecialchars($jahr, ENT_QUOTES);
   $monat = htmlspecialchars($monat, ENT_QUOTES);
   $tag = htmlspecialchars($tag, ENT_QUOTES);
   $tage = htmlspecialchars($tage, ENT_QUOTES);
   $bjahr = htmlspecialchars($bjahr, ENT_QUOTES);
   $bmonat = htmlspecialchars($bmonat, ENT_QUOTES);
   $btag = htmlspecialchars($btag, ENT_QUOTES);
   $pxbreite = htmlspecialchars($pxbreite, ENT_QUOTES);
   $pxhoehe = htmlspecialchars($pxhoehe, ENT_QUOTES);
   $zenith = htmlspecialchars($zenith, ENT_QUOTES);
   $lon = htmlspecialchars($lon, ENT_QUOTES);
   $lat = htmlspecialchars($lat, ENT_QUOTES);
   $ort = htmlspecialchars($ort, ENT_QUOTES);
   $diff = htmlspecialchars($diff, ENT_QUOTES);
   $at1 = htmlspecialchars($at1, ENT_QUOTES);
   $at2 = htmlspecialchars($at2, ENT_QUOTES);
   $at3 = htmlspecialchars($at3, ENT_QUOTES);
   $at4 = htmlspecialchars($at4, ENT_QUOTES);
   $at5 = htmlspecialchars($at5, ENT_QUOTES);
   $at6 = htmlspecialchars($at6, ENT_QUOTES);
   $at7 = htmlspecialchars($at7, ENT_QUOTES);
   $txtat = htmlspecialchars($txtat, ENT_QUOTES);
   $txtkw = htmlspecialchars($txtkw, ENT_QUOTES);
   $txtnm = htmlspecialchars($txtnm, ENT_QUOTES);
   $txtvm = htmlspecialchars($txtvm, ENT_QUOTES);
   $layout = htmlspecialchars($layout, ENT_QUOTES);
   $spalten = htmlspecialchars($spalten, ENT_QUOTES);
   $ueber = htmlspecialchars($ueber, ENT_QUOTES);




?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html;CHARSET=iso-8859-1">
<LINK REL="stylesheet" HREF="css/kalender.css" TYPE="text/css">
<title>Kalenderberechnungen</title>
</head>

<!--

Parameter:
==========

jahr             Kalenderjahr (vierstellig), default=akt. Jahr
monat            Monat (1/2-stellig), default=akt. Monat
tag              Tag
bjahr            Kalenderjahr (vierstellig), default=akt. Jahr
bmonat           Monat (1/2-stellig), default=akt. Monat
btag             Tag
tage             Differenz

was              "+" oder "-" oder "d"

pxbreite         Ausgabebreite in Pixeln, default=800 (ungefhr)
pxhoehe          Ausgabehoehe in Pixeln, default=600 (ungefhr)

zenith           Azimuthwinkel Sonnenstand, default=90,833 (Sonne hinter Horizont)
                 weitere sinnvolle Angaben: 96=civil 102=nautical 108=astronomical
lon              geo. Laenge Standort (dezimal), default=7,2    (Sankt Augustin Npl)
lat              geo. Breite Standort (dezimal), default=50,767 (Sankt Augustin Npl)
diff             Differenz lokale Zeit zu UTC, default 1

at1 bis at7      Arbeitszeit Mo...So

ftx ...          x=variabel, hngt von verwendeter Datei ab! Enthlt Kz fr regionale
                 Arbeitstage

(c) privat http://galupki.de/

// -->

<body>

<form action="datumscalc.php" method="post">

<div class="monat">Datumsrechnung</div>

<table border="0">
  <tr>
    <td colspan="3">
      <hr>
    </td>
  </tr>
  <tr>
    <td>
      Datum<br>
      <input type="Text" name="tag" value="<?php echo $tag; ?>" size="2" maxlength="2">.
      <input type="Text" name="monat" value="<?php echo $monat; ?>" size="2" maxlength="2">.
      <input type="Text" name="jahr" value="<?php echo $jahr; ?>" size="4" maxlength="4">&nbsp;
    </td>
    <td align="center" colspan="2" class="grau">
      Optionen f&uuml;r Sonnenauf/-untergang bzw. D&auml;mmerung
    </td>
  </tr>
  <tr>
    <td>
    </td>
    <td class="grau">
      geo. Breite (lat)
    </td>
    <td class="grau">
      <input type="Text" name="lat" value="<?php echo $lat; ?>" size="10" maxlength="10">
    </td>
  </tr>
  <tr>
    <td></td>
    <td class="grau">
      geo. L&auml;nge (lon)
    </td>
    <td class="grau">
      <input type="Text" name="lon" value="<?php echo $lon; ?>" size="10" maxlength="10">
    </td>
  </tr>
  <tr>
    <td></td>
    <td class="grau">
      Differenz zu UT
    </td>
    <td class="grau">
      <input type="Text" name="diff" value="<?php echo $diff; ?>" size="3" maxlength="5">
    </td>
  </tr>
  <tr>
    <td></td>
    <td class="grau">
      D&auml;mmerung<br>
      daylight-time
    </td>
    <td class="grau">
      <input type="Radio" name="zenith" value="90.8333" <?php if ($zenith<=90.8333) {echo "checked=\"checked\"";}; ?>> offical
      <input type="Radio" name="zenith" value="96"      <?php if ($zenith==96)      {echo "checked=\"checked\"";}; ?>> civil
      <input type="Radio" name="zenith" value="102"     <?php if ($zenith==102)     {echo "checked=\"checked\"";}; ?>> nautical
      <input type="Radio" name="zenith" value="108"     <?php if ($zenith>=108)     {echo "checked=\"checked\"";}; ?>> astronomical&nbsp;<br>
    </td>
  </tr>
  <tr>
    <td colspan="3" align="left">
      <hr>
      <table border="0" width="100%">
        <tr>
          <td width="50%" valign="top">
            <input type="Radio" name="was" value="+"<?php if ($was=="+") {echo "checked=\"checked\"";}; ?>> plus
            <input type="Radio" name="was" value="-"<?php if ($was=="-") {echo "checked=\"checked\"";}; ?>> minus<br>
            &nbsp;<br>
            <input type="Text" name="tage" value="<?php echo $tage; ?>" size="15" maxlength="25"> Tage
          </td>
          <td width="50%" valign="top">
            <input type="Radio" name="was" value="d" <?php if ($was=="d" ) {echo "checked=\"checked\"";}; ?>> bis einschliesslich<br>
            &nbsp;<br>
            Datum
            <input type="Text" name="btag"   value="<?php echo $btag;   ?>" size="2" maxlength="2">.
            <input type="Text" name="bmonat" value="<?php echo $bmonat; ?>" size="2" maxlength="2">.
            <input type="Text" name="bjahr"  value="<?php echo $bjahr;  ?>" size="4" maxlength="4">
          </td>
        </tr>
        <tr>
          <td align="center">
            <?php
# reine Kosmetik
                  if ($was=="+" OR $was=="-") {
                     echo '<img src="image/lire.gif" width="63" height="44" border="0" alt="ermittelt neues Datum">';
                  }
            ?>
          </td>
          <td align="center">
            <?php
# reine Kosmetik
                  if ($was=="d") {
                     echo '<img src="image/reli.gif" width="66" height="44" border="0" alt="berechnet Differenz">';
                  }
            ?>
          </td>
        </tr>
        <tr>
          <td colspan="2" align="center">
            <hr>
            &nbsp;<br>
            <input type="Submit" name="submit" value="neu berechnen"><br>
            <br>
          </td>
        </tr>

        <tr>
          <td class="grau" colspan="2">
          <span class="fett">Optionen</span> (nur relevant bei Ergebniszeitraum  kleiner oder gleich 3 Jahre)<br>
          &nbsp;<br>
          Arbeitszeitfaktor in Tagen oder t&auml;gliche Arbeitszeit in Stunden
          <table border="0" width="100%">
            <tr>
              <td>
                Montag
              </td>
              <td>
                Dienstag
              </td>
              <td>
                Mittwoch
              </td>
              <td>
                Donnerstag
              </td>
              <td>
                Freitag
              </td>
              <td>
                Samstag
              </td>
              <td>
                Sonntag
              </td>
            </tr>
            <tr>
              <td>
                <input type="Text" name="at1" value="<?php echo $at1; ?>" size="5" maxlength="10">
              </td>
              <td>
                <input type="Text" name="at2" value="<?php echo $at2; ?>" size="5" maxlength="10">
              </td>
              <td>
                <input type="Text" name="at3" value="<?php echo $at3; ?>" size="5" maxlength="10">
              </td>
              <td>
                <input type="Text" name="at4" value="<?php echo $at4; ?>" size="5" maxlength="10">
              </td>
              <td>
                <input type="Text" name="at5" value="<?php echo $at5; ?>" size="5" maxlength="10">
              </td>
              <td>
                <input type="Text" name="at6" value="<?php echo $at6; ?>" size="5" maxlength="10">
              </td>
              <td>
                <input type="Text" name="at7" value="<?php echo $at7; ?>" size="5" maxlength="10">
              </td>
            </tr>
            <tr>
            <td colspan="7">
              Wochenarbeitszeit: <?php echo ($at1+$at2+$at3+$at4+$at5+$at6+$at7); ?> Tage / Stunden.
            </td>
            </tr>
          </table>
          </td>
        </tr>

        <tr>
          <td class="grau" colspan="2">
          &nbsp;<br>
          Arbeitszeit an regionalen Feiertagen (1=frei, 0.5=50%, 0=Arbeitstag usw.)
          <table border="0" width="100%">
            <tr>
<?php
# alle regionalen Feiertage
          $anz = 0;
          foreach ($fd->ft as $k => $f) {
             if ( $f["reg"]=="x" OR $f["reg"]=="X" ) {
                echo "<td align=\"right\">";
                echo $f["txt"] . ' <input type="Text" name="ft' . $k . '" value="' . $f["fak"] . '" size="6" maxlength="6">';
                echo "</td>\n";
                $anz++;
                if ( ($anz % 2) == 0 ) {
                   echo "</tr><tr>";
                }
             } // endif regional
          } // end foreach Feiertag
?>
            </tr>
          </table>
          </td>
        </tr>
        <tr>
          <td colspan="2">
            &nbsp;<br>
            <hr>
            &nbsp;<br>
            <div class="fett">Ergebnisse:</div>
          </td>
        </tr>
        <tr>
          <td colspan="2">
<?php

# Ergebnisdarstellung, Teil 1: Ursprungs- und Zieldatum (ug und og)
$ug = $kal->DatumInJultag($jahr, $monat, $tag);
tagDetails($ug);

echo "&nbsp;<br>";

switch ($was) {
case "+":       $og = $ug + $tage;
                echo "...plus $tage Tag(e)...<br>\n";
                break;
case "-":       $og = $ug - $tage;
                echo "...minus $tage Tag(e)...<br>\n";
                break;
case "d":       $og = $kal->DatumInJultag($bjahr, $bmonat, $btag);
                if ($og>$ug) {
                   $x = $og-$ug;
                }  else {
                   $x = $ug-$og;
                }
                $x++;
                echo "...Differenz betr&auml;gt (einschliesslich von/bis) $x Tag(e)...<br>\n";
                break;
default:
}

echo "&nbsp;<br>";

if ($ug!=$og) {
   tagDetails($og);
}

# *****************************************************************************************************
function tagDetails($jd) {
# Ergebnistabelle fr einen bestimmten Tag definieren

global $kal, $astro;
global $zenith, $lon, $lat, $diff;

$kal->JultagInDatum($jd);

# sonne
$astro->sun("rising",  $kal->jahr, $kal->monat, $kal->tag, $zenith, $lon, $lat, $diff);
$sAufgang = $astro->sun_hh . ":" . sprintf ("%02d", $astro->sun_mm);
$astro->sun("setting", $kal->jahr, $kal->monat, $kal->tag, $zenith, $lon, $lat, $diff);
$sUntergang = $astro->sun_hh . ":" . sprintf ("%02d", $astro->sun_mm);

# mond
$astro->moon($kal->jahr, $kal->monat, $kal->tag);

# kalenderangaben
$lfdtag = $kal->LfdTagJahrJultag($jd);
$wotag  = $kal->WoTag($kal->JultagInWotag($jd));
$woche  = $kal->WochenNr($kal->jahr, $kal->monat, $kal->tag);

# Ergebnistabelle
echo "<table border=\"1\" width=\"100%\">\n";
echo "<tr>\n";
echo "<td class=\"gruen\">Datum</td><td class=\"gruen\">Lfd. Tag</td><td class=\"gruen\">Wochentag</td><td class=\"gruen\">KW</td><td class=\"gruen\">jul. Tag</td><td class=\"gruen\">Sonne</td><td class=\"gruen\">Mond</td>\n";
echo "</tr>\n";
echo "<tr>\n";
echo "<td>$kal->tag.$kal->monat.$kal->jahr</td><td>$lfdtag</td><td>$wotag</td><td>$woche</td><td>$jd</td><td>$sAufgang - $sUntergang</td><td>$astro->moonage Tage, $astro->moonvisible %<br>$astro->moonphase</td>\n";
echo "</tr>\n";
echo "</table>\n";

} // end function tagDetails
# *****************************************************************************************************

?>
          </td>
        </tr>

      </table>
    </td>
  </tr>
</table>
</form>

<?php

if ($ug>$og) {
# vertauschen falls noetig
   $x  = $ug;
   $ug = $og;
   $og = $x;
}

if (($og-$ug)<1100) {
# Ergebnisdarstellung, Teil 2: Liste aller Feiertage/Termine sowie Statistik
# aber nur, wenn es nicht zu lang wird (ca. 3 Jahre maximal)
   tabelle();
}

# *****************************************************************************************************
function tabelle() {

global $ug, $og;
global $fd, $kal;

$tk = array( 1 => 0,0,0,0,0,0,0);  // Kalendertage
$ta = array( 1 => 0,0,0,0,0,0,0);  // Arbeitstage
$tf = array( 1 => 0,0,0,0,0,0,0);  // Feiertage
# und deren Spalten-Summen
$tsk = 0;
$tsa = 0;
$tsf = 0;

# layout-Tabelle fr zwei Spalten
echo "<table border=\"0\" width=\"$pxbreite\">\n";
echo "<tr><td width=\"50%\" align=\"left\" valign=\"top\">\n";

#Feiertagstabelle
echo "<table border=\"1\">\n";
echo "<tr>";
echo "<td colspan=\"3\" class=\"gruen\">Ber&uuml;cksichtigte Feiertage</td>\n";
echo "</tr>\n";

$kal->JultagInDatum($ug);
$fd->Kalenderjahr($kal->jahr);

for ($jd=$ug; $jd<=$og; $jd++) {
# ueber alle JD zwischen UG und OG
    $kal->JultagInDatum($jd);

    if ($kal->jahr!=$fd->aktjahr) {
# Jahreswechsel erfolgte, Zuordnungstabelle neu aufbauen
       $fd->Kalenderjahr($kal->jahr);
    }

    $lfdnr = $kal->LfdTagJahr($kal->jahr, $kal->monat, $kal->tag);
    $wotag = $kal->JultagInWotag($jd);

# arbeitszeitfaktor Kalendertag
    $arbeitstag = $fd->Arbeitstag($lfdnr);
    if ($arbeitstag<1) {
       $tf[$wotag] += 1 - $arbeitstag;
       $tsf        += 1 - $arbeitstag;
    }

    if ($fd->at[$wotag]==0) {
# sowieso frei nach definition
       $arbeitstag = 0;
    }  else {
# bewertung mit Feiertagsfaktor
       $arbeitstag = $arbeitstag * $fd->at[$wotag];
    }

# Summentabellen - Rest
    $tk[$wotag] += 1;
    $tsk        += 1;
    $ta[$wotag] += $arbeitstag;
    $tsa        += $arbeitstag;

# texte der Termine/Feiertage
    if ($fd->jahrt[$lfdnr]>0) {
       $tab = explode(";", $fd->jahrt[$lfdnr]);
       foreach ($tab as $f) {
          if ($fd->ft[$f]["fak"]>0  AND  $f>0) {
             echo "<tr>";
             echo "<td class=\"textFrei\">" . $kal->WoTag($wotag) . "</td>";
             echo "<td class=\"textFrei\"> $kal->tag.$kal->monat.$kal->jahr </td>";
             echo "<td class=\"textFrei\">" . $fd->ft[$f]["txt"];
             if ($fd->ft[$f]["fak"]<1) {
                echo " (Arbeitszeitfaktor " . $fd->ft[$f]["fak"] . ")";
             }
             echo "</td>";
             echo "</tr>\n";
          }  elseif ($f>0) {
             echo "<tr>";
             echo "<td class=\"textArbeit\">" . $kal->WoTag($wotag) . "</td>";
             echo "<td class=\"textArbeit\"> $kal->tag.$kal->monat.$kal->jahr </td>";
             echo "<td class=\"textArbeit\">" . $fd->ft[$f]["txt"] . "</td>";
             echo "</tr>\n";
          }
       }
    }
} // for
echo "</table>\n";
echo "</td>\n";
echo "<td align=\"right\" valign=\"top\">";

# Tabelle der Wochentags-Statistik
echo "<table border=\"1\">\n";
echo "<tr>";
echo "<td colspan=\"4\" class=\"gruen\">Statistik der Wochentage</td>\n";
echo "</tr>\n";
echo "<tr>";
echo "<td class=\"gruen\">Tag</td>";
echo "<td class=\"gruen\" align=\"right\">Kalender-<br>tage</td>";
echo "<td class=\"gruen\" align=\"right\">Arbeits-<br>zeit</td>";
echo "<td class=\"gruen\" align=\"right\">Feier-<br>tage</td>";
echo "</tr>\n";

for ($i=1; $i<=7; $i++) {
    echo "<tr>";
    echo "<td class=\"gruen\">" . $kal->WoTag($i) . "</td>";
    echo "<td align=\"right\">" . $tk[$i] . "</td>";
    echo "<td align=\"right\">" . $ta[$i] . "</td>";
    echo "<td align=\"right\">" . $tf[$i] . "</td>";
    echo "</tr>\n";
}

echo "<tr>";
echo "<td class=\"gruen\">&sum;</td>";
echo "<td align=\"right\">" . $tsk . "</td>";
echo "<td align=\"right\">" . $tsa . "</td>";
echo "<td align=\"right\">" . $tsf . "</td>";
echo "</tr>\n";
echo "</table>\n";

echo "</td></tr></table>\n";

} // end function tabelle
# *****************************************************************************************************

?>

</body>
</html>