<?php
// (c) Juergen Galupki  http://galupki.de

#require_once("kalender.class.php");

class feiertage {

var $aktjahr = 0;      // Kalenderjahr
var $offset  = 0;      // julianischesDatum 1.1.Kalenderjahr - 1
var $jahrt;            // enthaelt fuer [1-366] in weiteren Dimensionen 0 oder Verweis auf $ft
var $ft;               // enthaelt fuer das Jahr die entsprechenden Details (Dateiinhalt mit Ergnzungen)
var $zeilen = 0;       // Naechster Index in ft

var $at = array (1 =>  // enthaelt den Arbeitszeitfaktor fuer die einzelnen Wochentage
                 1,      // Mo
                 1,      // Di
                 1,      // Mi
                 1,      // Do
                 1,      // Fr
                 0,      // Sa
                 0       // So
                );


function setzeArbeitstage( $mo, $di, $mi, $do, $fr, $sa, $so ) {
# setzt die vorgegebenen Arbeitszeitfaktoren (default siehe init von $at)
   $this->at[1] = $mo;
   $this->at[2] = $di;
   $this->at[3] = $mi;
   $this->at[4] = $do;
   $this->at[5] = $fr;
   $this->at[6] = $sa;
   $this->at[7] = $so;
}



function liesFeiertage($datei) {
# liest Feiertags-/Termindatei ein
# ggfs. auch mehrere Dateien nacheinander moeglich...

  $fp = fopen ($datei,"r");
  while ($data = fgetcsv ($fp, 1000, ";")) {
   if (
           $data[1]=="D"
        OR $data[1]=="F"
        OR $data[1]=="O"
        OR $data[1]=="T"
        OR $data[1]=="J"
        OR $data[1]=="M"
        OR $data[1]=="P"
      ) {
      $this->ft[$this->zeilen] =
      array(
      "txt"=>htmlentities($data[0]),  // feiertagstext
      "typ"=>$data[1],  // typ D(atfloat) F(ix) O(stern) T(agDerWocheFloat) J(ahreszeit) M(uttertag) P(eriodisch)
      "anz"=>$data[2],  // anzahl oder nummer
      "tag"=>$data[3],  // tag
      "mon"=>$data[4],  // monat
      "von"=>$data[5],  // erstmalig in Jahr
      "btg"=>$data[6],  // letztmalig tag
      "bmt"=>$data[7],  // letztmalig monat
      "bis"=>$data[8],  // letztmalig in Jahr
      "wie"=>$data[9],  // wiederholungsregel
      "dif"=>$data[10], // differenztage zum zunaechst ausger. Datum
      "aus"=>$data[11], // ausnahmeregel
      "lay"=>$data[12], // Layout J(ahresanzahl) V(onjahr) B(isjahr)
      "fak"=>$data[13], // arbeitsfrei-Faktor
      "reg"=>$data[14], // Reginalkennzeichen Feiertag
      "not"=>$data[15]  // Aufzaehlung von expliziten Ausnahmetagen t.m.jahr[,t.m.jahr...]
      );
      $this->zeilen++;
   }

  } /* end WHILE datensaetze */
  fclose ($fp);
} // end function liesFeiertage




function IsNotTag($jahr, $monat, $tag, $zeile) {
# $zeile ist Aufzaehlung von expliziten Datuemern t.m.jahr [,t.m.jahr...]
# liefert true oder false zurueck (Datum in $zeile enthalten oder nicht)


if (trim($zeile)=="") {
   return(false);
}


$orgd = explode(",", $zeile);                 // array aller tage

foreach ($orgd as $datum) {

   $edatum = explode(".", $datum);

   if ( $edatum[0]==$tag
   AND  $edatum[1]==$monat
   AND  $edatum[2]==$jahr  ) {
      return(true);
   }

}

return(false);

} // end function getDatuemer






function Kalenderjahr($jahr) {
# berechnet reale Datuemer in $this->ft fuer das angegebene Jahr
# in "t" "m" "j" "jt" "wt" (tag monat jahr jultag wochentagnr
# traegt ausserdem ALLE Termine in JAHRT ein!
# ACHTUNG: Berechnung erfolgt zunaechst ungeachtet von+bis-Jahr Gueltigkeit
# und wird erst gegen Ende wieder entfernt

  $kal = new kalender;

# jahrestabelle initialisieren
  $this->aktjahr = $jahr;
  unset($this->jahrt);
  for ($i=1; $i <= $kal->TageImJahr($jahr); $i++) {
      $this->jahrt[$i] = "";
  }

  $kal->DatumInJultag($jahr, 1, 1);
  $this->offset = $kal->jultag - 1;

  $ostern = 0;
  $kal->Ostern($jahr);
  $ostern = $kal->jultag;


# fuer alle Elemente die JAEHRLICHEN Termine berechnen
  foreach ($this->ft as $k => $f) {

     $this->ft[$k]["t"] = 0;

     if ($f["wie"]=="T" OR $f["wie"]=="M") {
# taeglicher oder monatlicher Termin -> hier abbrechen, werden spaeter ausgewertet
        continue;
     }

# zunaechst berechnen regulaeres Datum in t.m.j
     switch ($f["typ"]) {
# fixer Feiertag - an einem bestimmten Tag
     case "F":
           $this->ft[$k]["t"] = $f["tag"];
           $this->ft[$k]["m"] = $f["mon"];
           $this->ft[$k]["j"] = $jahr;
        break;
# Muttertag
     case "M":
        $kal->Muttertag($jahr);
        $this->ft[$k]["t"] = $kal->tag;
        $this->ft[$k]["m"] = 5;
        $this->ft[$k]["j"] = $jahr;
        break;
# Jahreszeit
     case "J":
        $kal->Jahreszeitbeginn ($jahr, $this->ft[$k]["mon"]);
        $this->ft[$k]["t"] = $kal->tag;
        $this->ft[$k]["m"] = $kal->monat;
        $this->ft[$k]["j"] = $jahr;
        break;
# relativ zu Ostersonntag
     case "O":
        $jd = $ostern + $this->ft[$k]["anz"];
        $kal->JultagInDatum($jd);
        $this->ft[$k]["t"] = $kal->tag;
        $this->ft[$k]["m"] = $kal->monat;
        $this->ft[$k]["j"] = $jahr;
        break;
# naechster bestimmter Wochentag ab einem bestimmten Datum
     case "D":
        $kal->naechsterWotag($jahr, $this->ft[$k]["mon"], $this->ft[$k]["tag"], $this->ft[$k]["anz"]);
        $this->ft[$k]["t"] = $kal->tag;
        $this->ft[$k]["m"] = $kal->monat;
        $this->ft[$k]["j"] = $kal->jahr;
        break;
# n.-ter Wochentag eines Monats
     case "T":
        $nr = $this->ft[$k]["tag"];
        if ($nr=="L") {
           $nr = 6;
        }
        $kal->nterWotag($jahr, $this->ft[$k]["mon"], $this->ft[$k]["anz"], $nr);
        $this->ft[$k]["t"] = $kal->tag;
        $this->ft[$k]["m"] = $kal->monat;
        $this->ft[$k]["j"] = $kal->jahr;
        break;
     default:
        $this->ft[$k]["t"] = 0;
        $this->ft[$k]["m"] = 0;
        $this->ft[$k]["j"] = 0;
     } // switch typ

# berechnen des Jultages
     $this->ft[$k]["jt"] = $kal->DatumInJultag($this->ft[$k]["j"], $this->ft[$k]["m"], $this->ft[$k]["t"]);
     if ($this->ft[$k]["dif"]!=0) {
# und evtl. anwenden der Differenztageregel
        $this->ft[$k]["jt"] += $this->ft[$k]["dif"];
        $kal->JultagInDatum($this->ft[$k]["jt"]);
        $this->ft[$k]["t"] = $kal->tag;
        $this->ft[$k]["m"] = $kal->monat;
        $this->ft[$k]["j"] = $kal->jahr;
     }

# wochentag
     $this->ft[$k]["wt"] = ($this->ft[$k]["jt"] % 7) + 1;

# Layoutdetails falls Beginnjahr angegeben ist sinnvoll
     switch ($f["lay"]) {
        case "J": $this->ft[$k]["ld"] = $jahr - $f["von"];
                  break;
        case "V": $this->ft[$k]["ld"] = $f["von"];
                  break;
        case "B": $this->ft[$k]["ld"] = $f["bis"];
                  break;
        default:
     } // switch

# ausnahmeregel - nur alle ...ausnahme... Jahre
     if ( $f["aus"]>0  AND  $f["von"]>0 ) {
        if ( (($jahr - $f["von"]) % $f["aus"]) > 0 ) {
# schade, war alles umsonst
           $this->ft[$k]["t"] = 0;
        }  elseif ($f["lay"]="J") {
# korrektur der Anzahl der erfolgten Wiederholungen
           $this->ft[$k]["ld"] = floor(($jahr - $f["von"]) / $f["aus"]);
        }
     }

# Pruefung auf Ungueltigkeit - loeschen der Variablen
     if (
         ($this->ft[$k]["t"]==0)
         OR
         ($this->ft[$k]["von"]>0 AND $this->ft[$k]["von"]>$jahr)
         OR
         ($this->ft[$k]["bis"]>0 AND $this->ft[$k]["bis"]<$jahr)
         ) {
        $this->ft[$k]["ld"] = "";
        $this->ft[$k]["t"] = 0;
        $this->ft[$k]["m"] = 0;
        $this->ft[$k]["j"] = 0;
        $this->ft[$k]["jt"] = 0;
        $this->ft[$k]["wt"] = 0;
     }  else {
# Jahresindex aktualisieren mit Schluessel Feiertag (anhaengen)
        if ( !$this->IsNotTag($this->ft[$k]["j"], $this->ft[$k]["m"], $this->ft[$k]["t"], $this->ft[$k]["not"]) ) { // ###
           $this->jahrt[ (($this->ft[$k]["jt"]) - $this->offset) ] .= $k . ";";
        }
     }
  } // foreach


# jetzt fehlen noch taegliche, periodische, woechentliche, monatliche Termine
  foreach ($this->ft as $k => $f) {

     if ($f["wie"]!="T" AND $f["wie"]!="M") {
# jaehrlicher Termin -> schon erledigt
        continue;
     }

# zunaechst berechnen regulaeres Datum in t.m.j
     switch ($f["typ"]) {

# fix - fuer einen bestimmten Zeitraum
     case "F":
        if ($f["von"]<=$jahr AND $f["bis"]>=$jahr) {
           if ($f["wie"]=="T") {
# taeglich
              $ug = max($kal->DatumInJultag($jahr,1,1),$kal->DatumInJultag($f["von"],$f["mon"],$f["tag"])) - $this->offset;
              $og = min($kal->DatumInJultag($jahr,12,31),$kal->DatumInJultag($f["bis"],$f["bmt"],$f["btg"])) - $this->offset;
              for ($i=$ug; $i<=$og; $i++) {
                 $kal->JultagInDatum($i+$this->offset); // ###
                 if ( !$this->IsNotTag($kal->jahr, $kal->monat, $kal->tag, $this->ft[$k]["not"]) ) { // ###
                    $this->jahrt[$i] .= $k . ";";
                 }
              }
           } // end taeglich
           if ($f["wie"]=="M") {
# monatlich am n.ten eines Monats
              if ($f["von"]==$jahr) {
                 $ug = $f["mon"];
              }  else {
                 $ug = 1;
              }
              if ($f["bis"]==$jahr) {
                 $og = $f["bmt"];     // keine Pruefung ob Bistag kleiner als vontag
              }  else {
                 $og = 12;
              }
              if ($ug<=$og) {
                 for ($i=$ug; $i<=$og; $i++) {
                    if ( !$this->IsNotTag($jahr, $i, $f["tag"], $this->ft[$k]["not"]) ) { // ###
                       $this->jahrt[$kal->LfdTagJahr($jahr,$i,$f["tag"])] .= $k . ";";
                    }
                 }
              }
           } // end monatlich
        }
        break;

# periodischer termin
     case "P":
        if ($f["von"]<=$jahr AND $f["bis"]>=$jahr) {
# start und ende
           $ug = $kal->DatumInJultag($f["von"],$f["mon"],$f["tag"]);
           $og = $kal->DatumInJultag($f["bis"],$f["bmt"],$f["btg"]);
           if ($f["bis"]>$jahr) {
              $og = $kal->DatumInJultag($jahr,12,31);
           }
           for ($pday=$ug; $pday<=$og; $pday += $f["anz"]) {
               if ($pday>=$this->offset+1) {
                  $kal->JultagInDatum($pday); // ###
                  if ( !$this->IsNotTag($kal->jahr, $kal->monat, $kal->tag, $this->ft[$k]["not"]) ) { // ###
                     $this->jahrt[$pday-$this->offset] .= $k . ";";
                  }
               }
           }
        }
        break;

# naechster bestimmter Wochentag ab einem bestimmten Datum
     case "D":
        if ($f["von"]<=$jahr AND $f["bis"]>=$jahr) {
           if ($f["von"]==$jahr) {
              $ug = $f["mon"];
           }  else {
              $ug = 1;
           }
           if ($f["bis"]==$jahr) {
              $og = $f["bmt"];     // keine Pruefung ob Bistag kleiner als vontag
           }  else {
              $og = 12;
           }
           if ($ug<$og) {
              for ($i=$ug; $i<=$og; $i++) {
                 $kal->naechsterWotag($jahr, $i, $f["tag"], $f["anz"]);
                 if ($kal->jahr==$jahr AND $kal->monat==$i) {
                    if ( !$this->IsNotTag($kal->jahr, $kal->monat, $kal->tag, $this->ft[$k]["not"]) ) { // ###
                       $this->jahrt[$kal->LfdTagJahr($kal->jahr,$kal->monat,$kal->tag)] .= $k . ";";
                    }
                 }
              }
           }
        }
        break;

# n.-ter Wochentag eines Monats
     case "T":
        if ($f["von"]<=$jahr AND $f["bis"]>=$jahr) {
           if ($f["von"]==$jahr) {
              $ug = $f["mon"];
           }  else {
              $ug = 1;
           }
           if ($f["bis"]==$jahr) {
              $og = $f["bmt"];     // keine Pruefung ob Bistag kleiner als vontag
           }  else {
              $og = 12;
           }
           if ($ug<$og) {
              for ($i=$ug; $i<=$og; $i++) {
                  $nr = $this->ft[$k]["tag"];
                  if ($nr=="L") {
                     $nr = 6;
                  }
                  $kal->nterWotag($jahr, $i, $f["anz"], $nr);
                  if ($kal->jahr==$jahr AND $kal->monat==$i) {
                     if ( !$this->IsNotTag($kal->jahr, $kal->monat, $kal->tag, $this->ft[$k]["not"]) ) { // ###
                        $this->jahrt[$kal->LfdTagJahr($kal->jahr,$kal->monat,$kal->tag)] .= $k . ";";
                     }
                  }
              }
           }
        }
        break;

     default:
     } // switch typ
  } // foreach tag/monat


} // end function Kalenderjahr



function Arbeitstag($lfdtag) {
# liefert Arbeitszeitfaktor zwischen 0 und 1 fuer den lfd. Tag im Jahr
   $azf = 0;
   if ($this->jahrt[$lfdtag]!="") {
# alle angegebenen Feiertage pruefen
      $feiertage = explode(";", $this->jahrt[$lfdtag]);
      foreach ($feiertage as $f) {
         if ($f>0) {
            $azf = max( $this->ft[$f]["fak"], $azf );
         }
      }
   }
   return 1 - $azf;
} // end function Arbeitstag



function testprintFeiertage() {
# listet alle gelesenen Dateieintrge und die aktuelle Jahresindextabelle

  echo "<h2>" . $this->aktjahr . "</h2>\n";
  echo "<table border=\"1\" width=\"90%\">\n";
  echo "<tr><th>Tag</th><th>Typ</th><th>Anz / Nr</th><th>Tag</th><th>Monat</th>\n" .
       "<th>von Jahr</th><th>bis tag</th><th>bis monat</th><th>bis Jahr</th>\n" .
       "<th>Wiederh</th><th>Diff-Tage</th><th>Ausnahme</th><th>not-Tage</th><th>Layout</th>\n" .
       "<th>Arb.Zeit Faktor</th><th>regional</th><th>Datum</th><th>Jultag</th><th>WoTagNr</th><th>Layout Detail</th></tr>\n";

  foreach ($this->ft as $k => $f) {
     echo "<tr><td>";
     echo $k . ". " .
          $f["txt"] . "</td><td>" .
          $f["typ"] . "</td><td>" .
          $f["anz"] . "</td><td>" .
          $f["tag"] . "</td><td>" .
          $f["mon"] . "</td><td>" .
          $f["von"] . "</td><td>" .
          $f["btg"] . "</td><td>" .
          $f["bmt"] . "</td><td>" .
          $f["bis"] . "</td><td>" .
          $f["wie"] . "</td><td>" .
          $f["dif"] . "</td><td>" .
          $f["aus"] . "</td><td>" .
          $f["not"] . "</td><td>" .
          $f["lay"] . "</td><td>" .
          $f["fak"] . "</td><td>" .
          $f["reg"] . "</td><td>" .
          $f["t"] . "." . $f["m"] . "." . $f["j"] . "</td><td>" .
          $f["jt"] . "</td><td>" . $f["wt"] . "</td><td>" .
          $f["ld"] .
          "</td></tr>\n";
  } // foreach
  echo "</table><br>\n";
  echo "<p>\n";


  echo "<table border=\"1\">\n";
  echo "<tr><th>LfdTag</th><th>Feiertag(e)</th><th>Arbeitszeitfaktor</th></tr>\n";
  $tag = 0;
  foreach ($this->jahrt as $k => $f) {
     $tag++;
     echo "<tr>";
     echo "<td>$tag</td><td>";
     echo $f;
     echo "</td><td>";
     echo $this->Arbeitstag($tag);
     echo "</td></tr>\n";
  }
  echo "</table>\n";

} // end function testprintFeiertage


} // end class feiertage

?>