<?php
// (c) Juergen Galupki  http://galupki.de         

class kalender {

var $jahr    = 0;
var $monat   = 0;
var $tag     = 0;
var $jultag  = 0;
var $wotagnr = 0;
var $woche   = 0;


function WoTag($x) {
  switch ($x) {
    case 1:    return "Montag";
    case 2:    return "Dienstag";
    case 3:    return "Mittwoch";
    case 4:    return "Donnerstag";
    case 5:    return "Freitag";
    case 6:    return "Samstag";
    case 7:    return "Sonntag";
    case "Mo": return 1;
    case "Di": return 2;
    case "Mi": return 3;
    case "Do": return 4;
    case "Fr": return 5;
    case "Sa": return 6;
    case "So": return 7;
    case "Montag": return 1;
    case "Dienstag": return 2;
    case "Mittwoch": return 3;
    case "Donnerstag": return 4;
    case "Freitag": return 5;
    case "Samstag": return 6;
    case "Sonntag": return 7;
    default: return "";
  }
} // end function WoTag


function Monat($x) {
  switch ($x) {
    case 1:  return "Januar";
    case 2:  return "Februar";
    case 3:  return "Mrz";
    case 4:  return "April";
    case 5:  return "Mai";
    case 6:  return "Juni";
    case 7:  return "Juli";
    case 8:  return "August";
    case 9:  return "September";
    case 10: return "Oktober";
    case 11: return "November";
    case 12: return "Dezember";
    case "Januar":    return 1;
    case "Februar":   return 2;
    case "Mrz":      return 3;
    case "April":     return 4;
    case "Mai":       return 5;
    case "Juni":      return 6;
    case "Juli":      return 7;
    case "August":    return 8;
    case "September": return 9;
    case "Oktober":   return 10;
    case "November":  return 11;
    case "Dezember":  return 12;
    default: return "";
  }
} // end function Monat


function heute() {
   return $this->DatumInJultag(date("Y"), date("n"), date("j"));
} // end function heute


function DatumInJultag($y, $m, $d) {
# fortlaufende Julianische Tageszahl ermitteln (gueltige Jahre -4713 bis 4713)
    $m -= 3;
    if ($m<0) {
       $m += 12;
       $y--;
    }
    $JD = floor($y*365.25) + floor($m*30.6 + 0.5) + $d + 1721117;
    if ($JD>2299170) {
       $JD -= floor($y/100) - floor($y/400) - 2;
    }
    $this->jultag = $JD;
    return $JD;
}


function JultagInDatum($jd) {
# aus fortlaufender Julianischer Tageszahl ein Datum ermitteln (gueltige Jahre -4713 bis 4713)
    $tz = $jd - 1721117;
    if ($jd>2299160) {
       $tz += floor(($tz+2) / 36524.25) - floor(($tz+2) / 146097) - 2 ;
    }
    $y = floor(($tz-0.2) / 365.25);
    $r = $tz - floor($y * 365.25);
    $m = floor(($r - 0.5) / 30.6);
    $d = $r - floor($m * 30.6 + 0.5);
    $m += 3;
    if ($m>12) {
       $m -= 12;
       $y++;
    }
    $this->tag = $d;
    $this->monat = $m;
    $this->jahr = $y;
}


function JultagInWotag($jultag) {
# liefert wochentagsnummer (1=mo 2=di 3=mi 4=do 5=fr 6=sa 7=so) nach DIN1355
   $this->wotagnr = $jultag % 7;
   $this->wotagnr++;
   return $this->wotagnr;
} // end function JultagInWotag;


function DatumInWotag($jahr, $monat, $tag) {
# liefert wochentagsnummer (1=mo 2=di 3=mi 4=do 5=fr 6=sa 7=so) nach DIN1355
   $this->wotagnr = $this->DatumInJultag($jahr, $monat, $tag) % 7;
   $this->wotagnr++;
   return $this->wotagnr;
} // end function DatumInWotag



function Schaltjahr($jahr) {
# liefert 1 wenn Schaltjahr (true) oder 0 wenn gemeines Jahr (false)
#  RETURN (($jahr % 4) == 0) AND ((($jahr % 400) == 0) OR (($jahr % 100) <>0));
   if ((($jahr % 4) == 0) AND ((($jahr % 400) == 0) OR (($jahr % 100) <>0))) {
      return 1;
   } else {
      return 0;
   }
} // end function Schaltjahr


function TageImJahr($jahr) {
# Anzahl der Tage des Jahres
   RETURN 365 + $this->Schaltjahr($jahr);
} // end function TageImJahr


function TageImMonat($jahr, $monat) {
# Anzahl Tage im Monat ($jahr wird nur fuer Febr ausgewertet)
   switch ($monat) {
       case 1:
           return 31;
       case 2:
           return 28 + $this->Schaltjahr($jahr);
       case 3:
           return 31;
       case 4:
           return 30;
       case 5:
           return 31;
       case 6:
           return 30;
       case 7:
           return 31;
       case 8:
           return 31;
       case 9:
           return 30;
       case 10:
           return 31;
       case 11:
           return 30;
       case 12:
           return 31;
       default:
           return 0;
   }
} // end function TageImMonat


function LfdTagJahr($jahr, $monat, $tag) {
# Nr. lfd. Tag im Jahr
    if ($monat>0 AND $monat<13) {
       $anztage = $tag;
# Tage der Vormonate summieren
       for ($i = 1; $i < $monat; $i++) {
           $anztage += $this->TageImMonat($jahr, $i);
       }
       return $anztage;
    }  else {
       return 0;
    }
} // end function LfdTagJahr


function LfdTagJahrJultag($jd) {
# Nr. lfd. Tag im Jahr
    $this->JultagInDatum($jd);
    return $this->LfdTagJahr($this->jahr, $this->monat, $this->tag);
} // end function LfdTagJahrJultag


function DatumsDiff ($jahr1, $monat1, $tag1, $jahr2, $monat2, $tag2) {
# Differenztage zwischen zwei Datuemern (pos. oder negativ)
# um die ANZAHL der Tage zu ermitteln jeweils 1 addieren/subtrahieren
   return $this->DatumInJultag($jahr1, $monat1, $tag1) - $this->DatumInJultag($jahr2, $monat2, $tag2);
} // end function DatumsDiff


function DatumsRechnung($jahr, $monat, $tag, $diff) {
# liefert neues Datum in den Variablen der Klasse zurueck
   $jd = $this->DatumInJultag($jahr, $monat, $tag) + $diff;
   $this->jultag = $jd;
   $this->JultagInDatum($jd);
} // end function DatumsRechnung


function DatumsRechnungJultag($jd, $diff) {
# liefert neues Datum in den Variablen der Klasse zurueck
   $jd = $jd + $diff;
   $this->jultag = $jd;
   $this->JultagInDatum($jd);
} // end function DatumsRechnung


function WochenNr($jahr, $monat, $tag) {
# liefert die Wochennummer passend zum Datum nach DIN1355
# Eine Woche beginnt Montags
# Erste Woche im Jahr ist die mit min. 4 Tagen (also 1.1.=Mo-Do)
# Jahr hat 52/53 Wochen (53 nur wenn mit Donnerstag begonnen/beendet)

# bestimme Wochentagsnummern (0-6) fuer Vorjahr, Jahr, Folgejahr
  $wt11vj  = ($this->DatumInJultag($jahr-1, 1, 1) % 7);
  $wt11aj  = ($this->DatumInJultag($jahr,   1, 1) % 7);
  $wt11nj  = ($this->DatumInJultag($jahr+1, 1, 1) % 7);
# bestimme Lfd.Woche als Annaehrung
  $woche = $this->LfdTagJahr($jahr, $monat, $tag);
  $woche = floor( ($woche + $wt11aj - 1) / 7 );
# Korrektur: Jahr beginnt mit "eigener" Woche
  if ($wt11aj < 4) {
     $woche++;
  }
# Korrektur: Es gibt keine Woche 0, gehoert zum Vorjahr
  if ($woche == 0) {
     if ($wt11vj < 4) {
        $this->woche = 53;
        return 53;
     }  else {
        $this->woche = 52;
        return 52;
     }
# Korrektur: Letzte Tage des Jahres
  } elseif ($woche == 53  AND  $wt11nj < 4) {
# ... zum Folgejahr
    $this->woche = 1;
    return 1;
  } else {
# ... zum akt. Jahr
    $this->woche = $woche;
    return $woche;
  }
} // end function WochenNr


function WochenNrJultag($jd) {
# liefert die Wochennummer passend zum Datum nach DIN1355
# Eine Woche beginnt Montags
# Erste Woche im Jahr ist die mit min. 4 Tagen (also 1.1.=Mo-Do)
# Jahr hat 52/53 Wochen (53 nur wenn mit Donnerstag begonnen/beendet)
  $this->JultagInDatum($jd);
  $this->woche = $this->WochenNr($this->jahr, $this->monat, $this->tag);
  return $this->woche;
} // end function WochenNrJultag


function WochenBeginn($jahr, $woche) {
# liefert das Datum des ersten Tages (Montag) der angegebenen Woche DIN1355
# geht bestimmt noch eleganter...

# ermitteln lfdtag ungefhre Woche
  $lfdtag = $woche * 7 - 6;   // 1, 8, 15 ... 365
# evtl. Korrektur wenn erste Woche zum Vorjahr gehoert (beginnt Fr...So)
  if (($this->DatumInJultag($jahr, 1, 1) % 7) > 3) {
     $lfdtag += 7; // dann eine Woche weiter
  }
# vorlaeufig festschreiben
  $lfdtag = $this->DatumInJultag($jahr, 1, 1) + $lfdtag - 1;
  $xwoche = $this->WochenNrJultag($lfdtag);
# aber ggf. modifizieren
  if        ($xwoche < $woche) {
     $lfdtag += 7;
     $xwoche = $this->WochenNrJultag($lfdtag);
  }  elseif ($xwoche > $woche) {
     $lfdtag -= 7;
     $xwoche = $this->WochenNrJultag($lfdtag);
  }
# wertrueckgabe
  $lfdtag -= ($lfdtag % 7); // Montag der Woche
  $this->JultagInDatum($lfdtag);
  $this->jultag = $lfdtag;
  $this->wotagnr = 0;
  $this->woche = $woche;
# gibt es die woche ueberhaupt
  if ($xwoche != $woche) {
     $this->woche = 0;
     return 0;
  }  else {
     return 1;
  }
} // end function WochenBeginn


function nterWotag($jahr, $monat, $wotag, $nr) {
# der $nr .te $wotag im $monat
# falls $nr > 5  -letztes auftreten im Monat-
        $moerster = $this->DatumInJultag($jahr, $monat, 1);
        $xtag = $wotag - $this->JultagInWotag($moerster);
        if ($xtag < 0) {
           $ewotag = $xtag + 8;
        }  else {
           $ewotag = $xtag + 1;
        }
        $xtag = $ewotag + (7 * $nr - 7);
        if ($xtag > $this->TageImMonat($jahr, $monat)) {
           if ($nr > 5) {
              while ($xtag > $this->TageImMonat($jahr, $monat)) {
                    $xtag = $xtag - 7;
              }
           }  else {
              $xtag = 0;
           }
        }
        if ($xtag > 0) {
           $tag = $xtag;
        }  else {
           $tag = 0;
        }
        $this->tag = $tag;
        $this->monat = $monat;
        $this->jahr = $jahr;
        $this->jultag = $this->DatumInJultag($jahr, $monat, $tag);
        return $tag;
} // end function nterWotag


function naechsterWotag($jahr, $monat, $tag, $wotag) {
# erstes auftreten des $wotag am oder nach dem $tag.$monat.
   $jd = $this->DatumInJultag($jahr, $monat, $tag);
   $wd = $this->JultagInWotag($jd);
   $x = $wotag - $wd;
   if ($x < 0) {
      $x += 7;
   }
   $jd += $x;
   $this->jultag = $jd;
   $this->JultagInDatum($jd);
   if ($this->monat == $monat) {
      return $tag + $x;
   }  else {
      return 0; // zwar Datum ermittelt, aber im n. Monat
   }
} // end function naechsterWotag


function Jahreszeitbeginn ($jahr, $typ) {
# liefert fuer $typ den Beginntag der Jahreszeiten (+/- 1 Tag)
# typ ... 3=Fruehling, 6=Sommer, 9=Herbst, 12=Winter

  switch ($typ) {
     case 3:
             $tag = 20 + $this->Schaltjahr($jahr);
             break;
     case 6:
             $tag = 21;
             break;
     case 9:
             $tag = 22 + $this->Schaltjahr($jahr);
             break;
     case 12:
             $tag = 21 + $this->Schaltjahr($jahr);
             break;
     default:
             $tag = 0;
  }
  $this->jahr = $jahr;
  $this->monat = $typ;
  $this->tag = $tag;
  $this->jultag = $this->DatumInJultag($jahr, $typ, $tag);
  return $tag;
} // end function Jahreszeitbeginn


function Ostern($jahr) {
# Gausssche Osterformel Berechnung Ostersonntag
# diese Auspraegung ist gueltig 1900-2099
  $a = $jahr % 19;
  $b = $jahr % 4;
  $c = $jahr % 7;
  $d = ( 19 * $a + 24) % 30;
  $e = ( 2 * $b + 4 * $c + 6 * $d + 5) % 7;
  $tag = 22 + $d + $e;
  $monat = 3;
  if ($tag > 31) {
     $tag = $d + $e - 9;
     $monat = 4;
  }
  if ($tag == 26 AND $monat == 4) {
     $tag = 19;
  }
  if ($tag == 25 AND $monat == 4 AND $d == 28 AND $e == 6 AND $a > 10) {
     $tag = 18;
  }
  $this->jahr  = $jahr;
  $this->monat = $monat;
  $this->tag   = $tag;
  $this->jultag = $this->DatumInJultag($jahr, $monat, $tag);
} // end function Ostern


function OsterDiff($jahr, $diff) {
# liefert Differenztag zu Ostersonntag (diff=+1 ist z.B. Ostermontag)
  $this->Ostern($jahr);
  $this->DatumsRechnung($this->jahr, $this->monat, $this->tag, $diff);
} // end function OsternDiff


function Muttertag($jahr) {
# normalerweise 2. Sonntag im Mai
# wenn Muttertag und Pfingsten (49T nach Ostern) zusammenfallen allerdings eine Woche frueher

# Pfingstsonntag
  $this->OsterDiff($jahr, 49);
  $pfingstSo = $this->DatumInJultag($jahr, $this->monat, $this->tag);
# zweiter Maisonntag
  $maitag = $this->DatumInJultag($jahr, 5, 1);
  $wt15 = $maitag % 7;
  $maitag += (6 - $wt15) + 7;
# evtl. Woche frueher
  if ($pfingstSo == $maitag) {
     $maitag -= 7;
  }
  $this->JultagInDatum($maitag);
  $this->jultag = $maitag;
} // end function Muttertag

} // end class Feiertage


?>