<?php
// (c) Juergen Galupki  http://galupki.de


require_once("lib/kalender.class.php");
require_once("lib/feiertage.class.php");
require_once("lib/sonnemond.class.php");
require_once("lib/minikal.php");

$kal   = new kalender;
$fd    = new feiertage;
$astro = new sonnemond;



if ($css=="") {
   $css="kalender.css";
}  elseif (substr($css,0,5)=="print") {
   $pxbreite = 1050;
   $pxhoehe  = 400;
}


require_once("settings.php"); // <*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-*-* ggf. anpassen !!!



# Javascript - Warndienst bei Uhrzeiten
$jsnr  = 0;
$jsmsg = "";
if ($vorwarnsekunden=="") {
   $vorwarnsekunden = 15 * 60;
}


# Uebergabeparameter

# default: aktuelles Jahr/Monat
if ($jahr=="") {
   $jahr = date("Y");
}
if ($monat=="") {
   $monat = date("m");
}

# Texte
if ($txtat=="") {
   $txtat = "Arbeitstage";
}
if ($txtkw=="") {
   $txtkw = "KW";
}
if ($txtnm=="") {
   $txtnm = "Neumond";
}
if ($txtvm=="") {
   $txtvm = "Vollmond";
}

# fuer Berechnungen Tabellenfelder - groessen
if ($pxbreite=="") {
   $pxbreite = 750;
}
if ($pxhoehe=="") {
   $pxhoehe  = 500;
}


# $layout:   blatt (eine Woche in einer Zeile wie Kalenderblatt)
#            liste (jeder Tag in einer separaten Zeile, Wochen voneinander abgesetzt)
if ($layout=="") {
   $layout = "blatt";
}


# nur wenn $layout!="blatt" ist: Anzahl der Spalten rechts von Tagdetails - default 1 - max. 6
if ($spalten=="") {
   $spalten = 1;
}
$spalten = min(6,$spalten);


# Spaltenueberschriften
if ($layout=="liste") {
   if ($ueber=="") {
      $ueber = "&nbsp;*";
   }
   $ueberschriften = explode("*", $ueber);
   if ( count($ueberschriften)<$spalten) {
      for ( $i=count($ueberschriften); $i<$spalten; $i++ ) {
          $ueberschriften[$i] = "&nbsp;";
      }
   }
}



# Sonnenauf- und Untergangszeiten gewuenscht?
if ($sonne=="") {
   $sonne=true;
}
if ($zenith=="") {
   $zenith = 90.8333; // sonne geht/kommt hinter horizont
}
# default: Niederpleis :-)
if ($ort=="") {
   $ort    = "Sankt Augustin";
}
if ($lon=="") {
   $lon    = 7.2122;
}
if ($lat=="") {
   $lat    = 50.775;
}
# Abweichung zur UTC-Zeit: anzugeben sind Grunddifferenz Location und
# ggf. Beginn/Ende einer Sommerzeit in  $diff, $szb, $sze
if ($diff=="") {
# defaultberechnung wenn diff="": Differenz MESZ zu UTC
   $diff   = 1;
# check auf Sommerzeit
   if ($jahr>=1980) {
# beginn der sommerzeit
        $kal->nterWotag($jahr, 3, 7, 6); // letzter So im Mrz
        $szb = $kal->jultag;
# ende der sommerzeit
        if ($jahr>=1996) {
           $kal->nterWotag($jahr, 10, 7, 6); // letzter So im Oktober
        }  else {
           $kal->nterWotag($jahr, 3, 7, 6); // letzter So im September
        }
        $sze = $kal->jultag;
   }  else {
      $szb = 0;
      $sze = 0;
   }
}


$heute = $kal->heute();               // fuer Markierung akt. Tag
$anzat = 0;                           // Anzahl der Arbeitstage



   $css =  htmlspecialchars($css, ENT_QUOTES);
   $jahr = htmlspecialchars($jahr, ENT_QUOTES);
   $monat = htmlspecialchars($monat, ENT_QUOTES);
   $tag = htmlspecialchars($tag, ENT_QUOTES);
   $tage = htmlspecialchars($tage, ENT_QUOTES);
   $bjahr = htmlspecialchars($bjahr, ENT_QUOTES);
   $bmonat = htmlspecialchars($bmonat, ENT_QUOTES);
   $btag = htmlspecialchars($btag, ENT_QUOTES);
   $pxbreite = htmlspecialchars($pxbreite, ENT_QUOTES);
   $pxhoehe = htmlspecialchars($pxhoehe, ENT_QUOTES);
   $zenith = htmlspecialchars($zenith, ENT_QUOTES);
   $lon = htmlspecialchars($lon, ENT_QUOTES);
   $lat = htmlspecialchars($lat, ENT_QUOTES);
   $ort = htmlspecialchars($ort, ENT_QUOTES);
   $diff = htmlspecialchars($diff, ENT_QUOTES);
   $at1 = htmlspecialchars($at1, ENT_QUOTES);
   $at2 = htmlspecialchars($at2, ENT_QUOTES);
   $at3 = htmlspecialchars($at3, ENT_QUOTES);
   $at4 = htmlspecialchars($at4, ENT_QUOTES);
   $at5 = htmlspecialchars($at5, ENT_QUOTES);
   $at6 = htmlspecialchars($at6, ENT_QUOTES);
   $at7 = htmlspecialchars($at7, ENT_QUOTES);
   $txtat = htmlspecialchars($txtat, ENT_QUOTES);
   $txtkw = htmlspecialchars($txtkw, ENT_QUOTES);
   $txtnm = htmlspecialchars($txtnm, ENT_QUOTES);
   $txtvm = htmlspecialchars($txtvm, ENT_QUOTES);
   $layout = htmlspecialchars($layout, ENT_QUOTES);
   $spalten = htmlspecialchars($spalten, ENT_QUOTES);
   $ueber = htmlspecialchars($ueber, ENT_QUOTES);



$pxspalte = floor($pxbreite / 7);
$pxzeile  = min(floor($pxhoehe  / 7), 60);



?>
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.01 Transitional//EN">
<html>
<head>
<META HTTP-EQUIV="Content-Type" CONTENT="text/html;CHARSET=iso-8859-1">
<LINK REL="stylesheet" HREF="css/<?php echo $css; ?>" TYPE="text/css">
<title>Kalender</title>
</head>

<!--

Parameter:
==========

jahr             Kalenderjahr (vierstellig), default=akt. Jahr
monat            Monat (1/2-stellig), default=akt. Monat

pxbreite         Ausgabebreite in Pixeln, default=800 (ungefhr)
pxhoehe          Ausgabehoehe in Pixeln, default=600 (ungefhr)

css              CSS Style-Datei aus Unterverzeichnis ./css/
                 

layout           blatt (Woche Mo-So in einer Zeile, Wochen untereinander), default
                 liste (alle Tage untereinander)
spalten          nur wenn layout=liste: Anzahl der "leeren" Tabellenspalten neben Tagesangaben
ueber            nur wenn layout=liste: berschriften der "leeren" Tabellenspalten durch * getrennt

sonne            Ausgabe Zeiten Sonnauf- und -untergang, default=1 (=true) 0(=false)
zenith           Azimuthwinkel Sonnenstand, default=90,833 (Sonne hinter Horizont)
                 weitere sinnvolle Angaben: 96=civil 102=nautical 108=astronomical
ort              Bezeichnung geo. Ort
lon              geo. Laenge Standort (dezimal), default=7,2    (Sankt Augustin Npl)
lat              geo. Breite Standort (dezimal), default=50,767 (Sankt Augustin Npl)
diff             Differenz lokale Zeit zu UTC, default autom. nach MEZ (1 im Winter, 2 im Sommer)
szb              Sommerzeitbeginn als julianische Tageszahl (default autom. MEZ)
sze              Sommerzeitende als julianische Tageszahl (default autom. MEZ)

txtat            Text, default=Arbeitstage
txtkw            Text, default=KW
txtnm            Text, default=Neumond
txtvm            Text, default=Vollmond

vorwarnsekunden  bei aktivem Javascript Terminvorwarnungs-Popup (wenn Termintext mit hh:mm beginnt), default 900 (15 min)

(c) privat http://galupki.de/

// -->

<body>

<?php

# blaettern: vorhergehender / naechster Monat
if ($monat>1) {
   $mz = $monat - 1;
   $jz = $jahr;
}  else {
   $mz = 12;
   $jz = $jahr - 1;
}
if ($monat<12) {
   $mw = $monat + 1;
   $jw = $jahr;
}  else {
   $mw = 1;
   $jw = $jahr + 1;
}
$parameter = "txtat=$txtat&amp;txtkw=$txtkw&amp;txtnm=$txtnm&amp;txtvm=$txtvm&amp;pxbreite=$pxbreite&amp;pxhoehe=$pxhoehe&amp;"
           . "css=$css&amp;csvdatei=$csvdatei&amp;layout=$layout&amp;spalten=$spalten&amp;"
           . "sonne=$sonne&amp;zenith=$zenith&amp;lon=$lon&amp;lat=$lat&amp;diff=$diff&amp;szb=$szb&amp;sze=$sze&amp;"
           . "ueber=$ueber";


if ($layout=="liste") {
   echo "<table border=\"1\">\n";
}  else {
   echo "<table border=\"0\" rules=\"groups\">\n";
}

echo "<thead><tr>\n";
echo "<td colspan=\"7\">\n";

echo "<p class=\"hr\">";

echo "<table border=\"0\" width=\"100%\">\n";
echo "<tr>\n";

echo "<td class=\"footnote\" align=\"left\" width=\"20%\">\n";
minikal($jz, $mz, 0);
echo "</td>\n\n";

echo "<td width=\"5%\" align=\"center\" valign=\"middle\">";
if (substr($css,0,5)=="print") {
   echo "&nbsp;";
}  else {
   echo "<a href=\"monatsblatt.php?jahr=$jz&amp;monat=$mz&amp;$parameter\">";
   echo "<img src=\"image/pfeill.gif\" width=\"15\" height=\"15\" border=\"0\" alt=\"$jz $mz\">";
   echo "</a>";
}
echo "</td>\n\n";

echo "<td valign=\"middle\" align=\"center\" width =\"50%\" class=\"monat\">\n";
echo "&nbsp;";
echo $kal->Monat($monat);
echo "&nbsp;";
echo $jahr;
echo "&nbsp;\n";
echo "</td>\n\n";

echo "<td width=\"5%\" align=\"center\" valign=\"middle\">";
if (substr($css,0,5)=="print") {
   echo "&nbsp;";
}  else {
   echo "<a href=\"monatsblatt.php?jahr=$jw&amp;monat=$mw&amp;$parameter\">";
   echo "<img src=\"image/pfeilr.gif\" width=\"15\" height=\"15\" border=\"0\" alt=\"$jw $mw\">";
   echo "</a>";
}
echo "</td>\n";

echo "<td class=\"footnote\" align=\"right\" width=\"20%\">\n";
minikal($jw, $mw, 0);
echo "</td>\n";

echo "</tr>\n";
echo "</table>\n\n";

echo "</td>";
echo "</tr>\n";

echo "<tr>\n";

$pos = $kal->DatumInWotag($jahr, $monat, 1);

if ($layout=="blatt") {
   echo "<th class=\"wotagname\" width=\"$pxspalte\">" .  $kal->WoTag(1) . "</th>\n";
   echo "<th class=\"wotagname\" width=\"$pxspalte\">" .  $kal->WoTag(2) . "</th>\n";
   echo "<th class=\"wotagname\" width=\"$pxspalte\">" .  $kal->WoTag(3) . "</th>\n";
   echo "<th class=\"wotagname\" width=\"$pxspalte\">" .  $kal->WoTag(4) . "</th>\n";
   echo "<th class=\"wotagname\" width=\"$pxspalte\">" .  $kal->WoTag(5) . "</th>\n";
   echo "<th class=\"wotagname\" width=\"$pxspalte\">" .  $kal->WoTag(6) . "</th>\n";
   echo "<th class=\"wotagname\" width=\"$pxspalte\">" .  $kal->WoTag(7) . "</th>\n";
   echo "</tr></thead>\n";

//   echo "<tr><td colspan=\"7\">\n";
//   echo "<hr noshade color=\"#cc0000\" size=\"1\">\n";
//   echo "</td></tr>\n";

}  else { // layout liste

   echo "<td>&nbsp;</td><td>&nbsp;</td>";

   for ($i=1; $i<=$spalten; $i++) {
      echo "<td width=\"" . floor((($pxbreite-$pxspalte) / $spalten))  . "\" class=\"listeueber\">";
      echo $ueberschriften[$i-1];
      echo "</td>";
   }
   echo "</tr></thead>\n";

}

echo "<tr>\n";


$kal->DatumsRechnung($jahr, $monat, 1, ($pos*-1)+1);
if ($pos==1) {
# min. einen Tag Vorlauf; hier eine Vorlaufwoche
   $kal->jultag -= 7;
   $kal->JultagInDatum($kal->jultag);
}

# feiertage berechnen
$fd->Kalenderjahr($kal->jahr);

# $ug und $og sind jeweils Wochenbeginn der ersten Woche des Monats bzw.
# Ende der letzten Woche des Monats
   $ug = $kal->jultag;
   $og = $ug-1;
   do {
      $og += 7;
      $kal->JultagInDatum($og);
   } while ($kal->monat==$monat OR (($og-$ug)<28));
   $pos = 1;


# Tabelle ausgeben
     for ($xt=$ug; $xt<=$og; $xt++) {
         $kal->JultagInDatum($xt);
         if ($kal->jahr!=$fd->aktjahr) {
# feiertage berechnen (moeglich bei Vorlauf/Nachlauftagen)
            $fd->Kalenderjahr($kal->jahr);
         }

         if ($layout!="blatt") {
# linke erste Spalte
            echo "<td valign =\"top\" class=\"wotag" . $kal->WoTag($pos) . "\">";
            echo "<b>" . $kal->WoTag($pos) . "</b>";
            echo "</td>";
         }

         $arbeitstag = tagAusgeben($kal->LfdTagJahr($kal->jahr,$kal->monat,$kal->tag));

         if ($layout!="blatt") {
# rechte Spalte(n)
            for ($i=1;$i<=$spalten;$i++) {
               echo "<td width=\"" . floor((($pxbreite-$pxspalte) / $spalten))  . "\" class=\"liste\">";
               echo "&nbsp;";
               echo "</td>";
            }
         }

         if ($fd->at[$pos]==0 OR $kal->monat!=$monat) {
            $arbeitstag = 0;
         }  else {
            $arbeitstag = $arbeitstag * $fd->at[$pos];
         }
         $anzat = $anzat + $arbeitstag;
         $pos++;
         if ($pos==8) {
            if ($layout!="blatt") {
               echo "</tr></table>\n";
               echo "&nbsp;<br>\n";
               echo "<table border=\"1\">\n";
               echo "<tr>\n";
            }  else {
               echo "</tr>\n<tr>\n";
            }
            $pos = 1;
         }  elseif ($layout!="blatt") {
            echo "</tr>\n<tr>\n";
         }
     }

echo "<td colspan=\"3\" width=\"" . $pxspalte*3  . "\" class=\"anzarbtage\">\n";

echo $anzat . " $txtat &nbsp;</td>\n";

echo "<td colspan=\"4\" width=\"" . ($pxspalte*4+20)  . "\" class=\"footnote\" align=\"right\">\n";

echo "$ort ";

//umrechnen dezimal in Spaehrische Koordinaten
$st = floor($lat);
$mi = floor(($lat - floor($lat))*60.0);
$se = floor((($lat - floor($lat) - $mi/60.0)*3600.0)+0.5);
IF ($se > 59.0) $se = 59.0;
printf(" %2d&deg;%02d&prime;%02d&prime;&prime; N ", $st, $mi, $se);

//umrechnen dezimal in Spaehrische Koordinaten
$st = floor($lon);
$mi = floor(($lon - floor($lon))*60.0);
$se = floor((($lon - floor($lon) - $mi/60.0)*3600.0)+0.5);
IF ($se > 59.0) $se = 59.0;
printf(" %2d&deg;%02d&prime;%02d&prime;&prime; E ", $st, $mi, $se);


$sw = $zenith - 90;

switch (floor($zenith)) {
   case 90:  echo "official daylight time";
             break;
   case 96:  echo "civil daylight time";
             break;
   case 102: echo "nautical daylight time";
             break;
   case 108: echo "astronomical daylight time";
             break;
   default:  echo "$sw&deg;";
}


echo "</td></tr>\n</table>\n";


echo "</body>\n";
echo "</html>\n";


function tagAusgeben($lfdnr) {
# einen Tag ausgeben
global $txtkw, $txtnm, $txtvm, $layout;
global $pxbreite, $pxhoehe, $pxspalte, $pxzeile, $css;
global $kal;
global $fd;
global $astro;
global $sonne, $zenith, $lon, $lat, $diff;
global $xt, $heute, $szb, $sze;
global $jahr;
global $monat;
global $pos;    // wochentag
global $jsmsg, $jsnr, $vorwarnsekunden;

# Sonnenauf- und Untergang
if ($sonne==true) {
   $sz = 0;
   if ($szb>0) {
# Sommerzeit ist angegeben
      if ($xt>=$szb AND $xt<=$sze) {
         $sz = 1;
      }
   }
   $astro->sun("rising",  $kal->jahr, $kal->monat, $kal->tag, $zenith, $lon, $lat, $diff+$sz);
   $sAufgang = $astro->sun_hh . ":" . sprintf ("%02d", $astro->sun_mm);
   $astro->sun("setting", $kal->jahr, $kal->monat, $kal->tag, $zenith, $lon, $lat, $diff+$sz);
   $sUntergang = $astro->sun_hh . ":" . sprintf ("%02d", $astro->sun_mm);
}  else {
   $sAufgang="";
   $sUntergang="";
}

$arbeitstag = $fd->Arbeitstag($lfdnr);

if ($arbeitstag==0) {
   $klasse = "Frei";
}  else {
   $klasse = substr($kal->WoTag($pos),0,2);
}
$klasse = "wotag" . $klasse;

if ($kal->monat != $monat) {
   $klasse = "anderermon";
}

$tab = explode(";", $fd->jahrt[$lfdnr]);

echo "<td class =\"$klasse\" style=\"width:{$pxspalte}px; height:{$pxzeile}px";
# Rahmen falls heute
if ( ($xt==$heute) AND (substr($css,0,5)!="print")) {
   echo "; border:1px solid #cc0000";
}  else {
   echo "; border:1px solid #e1e1e1";
}
echo "\" valign=\"top\">\n";


#tagesnummer
echo "<table width=\"100%\" border=\"0\">\n";
echo "<tr><td class =\"$klasse\" valign=\"top\"><div class=\"tagzahl\"><b>" . $kal->tag . ".</b></div>&nbsp;</td>\n";

echo "<td class =\"$klasse\" valign=\"top\" align=\"center\">";
if ($sonne==true) {
# Sonnenauf- untergang
   echo "<div class=\"sonne\">";
   echo $sAufgang . "-" . $sUntergang;
   echo "</div>";
}
echo "</td>\n";

# lfdtag im Jahr
echo "<td class =\"$klasse\" valign=\"top\" align=\"right\">";
echo "<div class=\"lfdtag\">";
echo "(" . $lfdnr . ")";

#woche
if ($pos==1) {
# montags Wochennummer
   echo "<br>$txtkw " . $kal->WochenNr($kal->jahr, $kal->monat, $kal->tag);
}
# mondphase
$astro->moon ($kal->jahr, $kal->monat, $kal->tag);
switch ($astro->moonage) {
   case 0:
       echo '<br><img src="image/neumond.gif" alt="' . $txtnm . '" border="0">';
       break;
   case 15:
       echo '<br><img src="image/vollmond.gif" alt="' . $txtvm . '" border="0">';
       break;
   default: ;
}


echo "</div>";
echo "</td>\n</tr>\n";

echo "</table>\n";

if ($layout=="blatt") {
   echo "&nbsp;<br>\n";
}

# texte der Termine/Feiertage
foreach ($tab as $f) {
   if ($f=="") {
      continue;
   }
   if ($fd->ft[$f]["fak"]>0) {
      echo "<div class=\"textFrei\">";
   }  else {
      echo "<div class=\"textArbeit\">";
   }

# JavaScript-Warndienst
   $form1 = "";
   $form2 = "";
   if ($xt==$heute) {

      $jsmsg = $fd->ft[$f]["txt"];
      $hh = substr($jsmsg,0,2);
      $trenner = substr($jsmsg, 2,1);
      $mm = substr($jsmsg,3,2);

      if ( $trenner==":"
           AND ( $hh>="00" and $hh<="24" )
           AND ( $mm>="00" and $mm<="59" ) ) {

         $terminzeit = mktime($hh,$mm);
         $jetztzeit  = mktime();
//         echo "<br>terminzeit $terminzeit<br>jetztzeit $jetztzeit<br>";
         $differenz  = $terminzeit - $jetztzeit;

         if ( $differenz > 0 ) {
            $form1 = "<span class=\"terminkommt\">";
            $form2 = "</span>";
            $wecker = $differenz - $vorwarnsekunden;
            if ( $wecker > $vorwarnsekunden ) {
               $differenz = $wecker;
            }  else {
               $differenz = 4;
            }
            $differenz = $differenz * 1000; // microsekunden fuer Javascript
            $jsnr++;
?>

            <script type="text/javascript">
            <!--
                 function Hinweis<?php echo $jsnr; ?>() {
                    var x = alert("<?php echo $jsmsg; ?>");
                 }
                 window.setTimeout("Hinweis<?php echo $jsnr; ?>()",<?php echo $differenz; ?>);
            //-->
            </script>
<?
         }  else { // Termin ist vorbei
            $form1 = "<span class=\"terminwar\">";
            $form2 = "</span>";

         } // endif differenz positiv
      } // endif ist eine Uhrzeitangabe
   } // endif heute


   echo $form1 . $fd->ft[$f]["txt"] . $form2;

   if ($fd->ft[$f]["ld"]!="") {
      echo " (" . $fd->ft[$f]["ld"] . ")";
   }
   echo "</div>";
}

if ($xt==$heute) {
//   echo "</div>";
}

echo "</td>\n";

return $arbeitstag;

} // end function tagAusgeben
?>